/*
 * tst_getsize.c --- this function tests the getsize function
 * 
 * Copyright (C) 1997 by Theodore Ts'o.
 * 
 * %Begin-Header%
 * This file may be redistributed under the terms of the GNU Public
 * License.
 * %End-Header%
 */

#include <stdio.h>
#include <string.h>
#if HAVE_UNISTD_H
#include <unistd.h>
#endif
#include <fcntl.h>
#include <time.h>
#include <sys/stat.h>
#include <sys/types.h>
#if HAVE_ERRNO_H
#include <errno.h>
#endif

#include "ext2_fs.h"
#include "ext2fs.h"

int main(int argc, const char *argv[])
{
	errcode_t	retval;
	blk_t		blocks;

	if (argc < 2) {
		fprintf(stderr, "%s device\n", argv[0]);
		exit(1);
	}
	retval = ext2fs_get_device_size(argv[1], 1024, &blocks);
	if (retval) {
		com_err(argv[0], retval, "while getting device size");
		exit(1);
	}
	printf("%s is device has %d blocks.\n", argv[1], blocks);
	return 0;
}
